local UPDATEPERIOD, elapsed = 5.0, 0
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject("BrokerHSK", {type = "data source", text = "HazLoot SK"})
local f = CreateFrame("frame")

f:SetScript("OnUpdate", function(self, elap)
    elapsed = elapsed + elap
    if elapsed < UPDATEPERIOD then return end

    elapsed = 0
    local count = HSK:GetPresentCount()
    dataobj.text = string.format("Present: %d", count)
end)

function dataobj:OnTooltipShow()
  self:AddLine("Raiders present:")
  local list = HSK:GetPresentList()
  for i,entry in ipairs(list) do
    for j,k in pairs(entry) do self:AddLine(i..". "..k.." ["..j.."]") end
  end
  self:AddLine(" ")
  self:AddLine(HazLoot:ReportCurrentState())
end

function dataobj:OnEnter()
    GameTooltip:SetOwner(self, "ANCHOR_NONE")
    GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
    GameTooltip:ClearLines()
    dataobj.OnTooltipShow(GameTooltip)
    GameTooltip:Show()
end

function dataobj:OnLeave()
    GameTooltip:Hide()
end

