HSK_Frame = CreateFrame("Button", "HSK_Frame", UIParent)
HSK_Frame:SetWidth(200)
HSK_Frame:SetHeight(600)
HSK_Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 150, -50)
HSK_Frame:SetScript("OnClick", HSK_Frame.Hide)
HSK_Frame:SetScript("OnDragStart", HSK_Frame.StartMoving)
HSK_Frame:SetScript("OnDragStop", function(self)
	self:StopMovingOrSizing()
end)
HSK_Frame:SetMovable(true)
HSK_Frame:EnableMouse(true)
HSK_Frame:RegisterForDrag("LeftButton")
HSK_Frame:RegisterForClicks("RightButtonUp")
HSK_Frame:Hide()

local texture = HSK_Frame:CreateTexture(nil,"BACKGROUND")
texture:SetTexture(0,0,0,0.2)
texture:SetAllPoints(HSK_Frame)
HSK_Frame.texture = texture

local cachedText = nil
local masterList = {}
local tFontString = nil

--- expects a array of {{name="",roles="",present=boolean,suicided=boolean,master=int},...}
function HSK_Frame:ShowList(title, raiders)
  title = "HazLoot \226\128\148 "..title or "HazLoot"
  if not tFontString then
    tFontString = HSK_Frame:CreateFontString(nil,"OVERLAY")
    tFontString:SetFont(STANDARD_TEXT_FONT, 14) 
    tFontString:SetJustifyH("CENTER")
    tFontString:SetShadowOffset(0.7, -0.7)
    tFontString:SetTextColor(1,0.3,0.3,1)
  end
  tFontString:SetText(title)
  tFontString:SetPoint("TOPLEFT", HSK_Frame, "TOPLEFT", 5, -5)

  local lastTop = -20 -- leaves room for title, and a gap
  local tmpText = nil
  for i,raider in ipairs(raiders) do
    if not masterList[i] then
      masterList[i] = HSK_Frame:CreateFontString(nil,"OVERLAY")
      masterList[i]:SetFont(STANDARD_TEXT_FONT, 10) 
      masterList[i]:SetJustifyH("LEFT")
      masterList[i]:SetShadowOffset(0.7, -0.7)
    end
    if raider.present and raider.suicided then
      masterList[i]:SetTextColor(0.8, 0.8, 1)
    elseif raider.present then
      masterList[i]:SetTextColor(0.8, 1, 0.8)
    else
      masterList[i]:SetTextColor(1, 1, 1,0.7)
    end
    tmpText = i..". "..raider.name.." ("..(raider.roles or "unknown")..")"
    if raider.master then
      tmpText = tmpText.." ["..raider.master.."]"
    end
    masterList[i]:SetText(tmpText)
    masterList[i]:SetPoint("TOPLEFT", HSK_Frame, "TOPLEFT", 5, lastTop)
    lastTop = lastTop - 9
  end
  if #masterList > #raiders then
    for i = #raiders+1,#masterList do
      masterList[i]:SetText("")
    end
  end
  HSK_Frame:SetHeight(20+9*#raiders+5)
  HSK_Frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }});
  HSK_Frame:SetBackdropColor(0,0,0,0.5);
  HSK_Frame:Show()
end

HSK_Frame:RegisterEvent("ADDON_LOADED")
HSK_Frame:SetScript("OnEvent", function(frame, event, addon)
	HSK_Frame:UnregisterEvent("ADDON_LOADED")

	if not hazLootDB then hazLootDB = {} end
	HSK_Frame.db = hazLootDB
	HSK_Frame:SetPoint("CENTER", UIParent, HSK_Frame.db.x and "BOTTOMLEFT" or "BOTTOM", HSK_Frame.db.x or 0, HSK_Frame.db.y or 221)
end)
